/*******************************************************************************
* vxMsg.h			definitions to be used in conjunction with the
*				eurogam register server c library
*/
#ifndef INCmsgh
#define INCmsgh

#ifdef UNIX
#include <sys/types.h>
#else
#include <types.h>
#endif

#define MSG_VERS 0

#define MESSAGE_SERVER "egmsg"		   /* host name of central message server */

enum messageSeverityLevel
{
	MSG_S_MINIMUM     = 0,
	MSG_S_ZERO        = 0,
	MSG_S_TEST        = 1,
	MSG_S_DEBUG       = 2,
	MSG_S_INFORMATION = 3,
	MSG_S_WARNING     = 4,
	MSG_S_ERROR       = 5,
	MSG_S_ALARM       = 6,
	MSG_S_FAULT       = 7,
	MSG_S_FAILURE     = 8,
	MSG_S_CATASTROPHE = 9,
	MSG_S_MAXIMUM     = 9
};

enum messageClass
{
	MSG_C_TEST        = 0,
	MSG_C_MISC        = 1,
	MSG_C_AUTOFILL    = 2,
	MSG_C_HV          = 3,
	MSG_C_SPECTRUM    = 4,
	MSG_C_FRONTEND    = 5,
	MSG_C_HISTOGRAM   = 6,
	MSG_C_RM          = 7,
	MSG_C_ERS         = 8,

	MSG_C_MAXIMUM     = 99
};



#ifndef OK /* define possible function returns */
#define OK 0
#endif

#ifndef ERROR
#define ERROR (-1)
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE (!FALSE)
#endif

typedef struct msgList {
	u_int class;
	u_int lowLevel;
	u_int highLevel;
	u_int count;
	struct msgList *next;
}MSG_LIST;

extern int errno;

#ifdef	__STDC__

extern void		msgInstall ();

extern int		msgInitialise (char *host);
extern char *	msgPerror (char *string);
extern char *	msgVersion ();
extern char *	msgSeverity (u_int level);

extern int		msgNullProc ();
extern int		msgDefineMessage (u_int id, u_int class, u_int level, char *source, char *body);
extern int		msgSignOn (char *name, MSG_LIST *list);
extern int		msgSignOff (char *name);

#else

extern void		msgInstall ();

extern int		msgInitialise ();
extern char *	msgPerror ();
extern char *	msgVersion ();
extern char *	msgSeverity ();

extern int		msgNullProc ();
extern int		msgDefineMessage ();
extern int		msgSignOn ();
extern int		msgSignOff ();


#endif	/* __STDC__ */

#endif /* INCmsgh */
