
set frame          MIDASedit
set title          "MIDAS text editor"
set icon           MIDASedit

set directory $env(HOME)
set filename ""

proc browse_file {} {
    global env 
    global filename directory

    option add *Canvas.background  #c0c020
    set types {
    { {C Source Files } {*.c *.C *.cc *.cpp} }
    { {Tcl Files} {*.tcl} }
    { {All Files } {*} }
    }

    set ffile [tk_getOpenFile -parent [self frame-name] \
          -title "File Selection"  \
          -initialdir $directory -filetypes $types]

    option add *Canvas.background  $env(tkcanvasbackground)
    if {$ffile == ""} then {return}

    set directory [file dirname $ffile]   ;#  remember current choice
    set filename  $ffile
}

proc Edit_ {text}  {
    global env __editxlatedone

  :frame "[self frame-name].textedit" :label "[self frame-title]" :show-footer T  :resize F :toplevel T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]"

    set __editxlatedone 0
  
    :panel TEXTEDITPANEL :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 20

    :galley TEXTEDIT :rows 30 :cols 80 :font fixed
     :next-row T

    :button TEXTEDITDONE :label "Save file and finish"     :command Edit_done
    :button TEXTEDITQUIT :label "Quit without saving file" :command Edit_quit
    :show T

    :modify TEXTEDIT :strings "$text" :see 0

   vwait __editxlatedone

   if {$__editxlatedone == 1}  {
       set text "[[:path TEXTEDIT].text get 1.0 end]"
   } else {
       set text ""
   }

   destroy "[self frame-name].textedit"

   return $text
}

proc Edit_done {} {global __editxlatedone; set __editxlatedone 1}
proc Edit_quit {} {global __editxlatedone; set __editxlatedone 2}

proc Editor {} {    
    global filename directory

    browse_file 
    if {$filename == ""} {return}

    set z [ catch {open $filename r} f ]
    if { $z != 0 } then {
        midas-warning "Unable to open file $filename\n$f"
        return
    } else {
       foreach line [ split [ read $f ] \n ] {
         append contents $line "\n" 
       }
       close $f
    }

    set contents [Edit_ $contents ]
 
    if {$contents == ""} then {return}
   
    set z [ catch {open $filename w} f ]
    if {$z != 0} then {
        midas-warning "Unable to write file $filename\n$f"
        return
    } else {
        puts $f "$contents"
    }
    close $f
    set contents ""
    set-footer "$filename updated"
}


proc make-frame {} {

    :frame [self frame-name] :label "[self frame-title]" :icon-name "[self icon-title]"
     :button OPEN :command Editor :w 40

    :show T
}

