
#----------------------------------------------------------------------GM
set GM(frame-name) GM
set GM(frame-title) "Gainmatch Options"
set GM(icon-title) optGM

set GMconfigdefault [file join $env(HOME) .gainmatchdata]
set GM(config) $GMconfigdefault
set GM(theta)    0.0
set GM(velocity) 0.0
set GM(tolerance) 4.0
set GM(xrayfilter) 50
set GM(gain) 1.0
set GM(wcal0) 5.0
set GM(wcal1) 0.0
#    poly order is "actual" order - 1  (for easy of choice menu)
set GM(polyorder) 0
set GM(options) 0


proc GM.make-frame {} { 
   global env GM 

   catch {GM.unpack}

   :frame $GM(frame-name) :label "$GM(frame-title)" :show-footer F :toplevel T \
        :icon-image "@$env(ICONHOME)/spectrum"  \
           :icon-name $GM(icon-title) :resize F

   :panel GM-OPTIONS :layout T :padx 5 :pady 5
    :layout V; :row-gap 5

   :text GM-CONFIG :label "Data file:" :w 20 :valuex 18c :shifters T \
        :value $GM(config) :command "GM.opt config"
   :text GM-THETA :label "Detector angle:" :w 8 :valuex 18c \
        :value $GM(theta) :command "GM.opt theta"
   :text GM-VELOCITY :label "Velocity (v/c):" :w 8 :valuex 18c \
        :value $GM(velocity) :command "GM.opt velocity"
   :text GM-TOLERANCE :label "Tolerance:" :w 8 :valuex 18c \
        :value $GM(tolerance) :command "GM.opt tolerance"
   :text GM-XRAYFILTER :label "Xray filter:" :w 8 :valuex 18c \
        :value $GM(xrayfilter) :command "GM.opt xrayfilter"
   :text GM-GAIN :label "Gain:" :w 8 :valuex 18c \
        :value $GM(gain) :command "GM.opt gain"
   :text GM-WCAL0 :label "wcal\[0\]:" :w 8 :valuex 18c \
        :value $GM(wcal0) :command "GM.opt wcal0"
   :text GM-WCAL1 :label "wcal\[1\]:" :w 8 :valuex 18c \
        :value $GM(wcal1) :command "GM.opt wcal1"
   :choice GM-POLYORDER :label "poly order:"  :valuex 18c :strings [list 1 2] \
        :value $GM(polyorder) :command "GM.opt polyorder"
   :choice GM-VERBOSE :label "Output option:" :valuex 18c :strings [list 0 1 2 3] \
        :value $GM(options) :command "GM.opt options"

   :panel GM-BUTTONS :layout B :padx 5
    :layout H
   :button GM-SAVE  :label "Save as defaults" :command GM.save
    :hskip 75
   :button GM-HELP  :label Help :command click-help

   :show T
}

proc GM.opt {opt args} {
   global GM
   set GM($opt) [second $args]
   GM.announce
}

proc GM.unpack {} {
   global GM GMconfigdefault
   foreach p [get-eg-option gainmatch] {
      switch [first $p] {
      config {
          if {[second $p] == "NULL"} then {
             set GM(config) $GMconfigdefault
          } else {
             set GM(config) [second $p]
          }
        }
      velocity   {set GM(velocity) [second $p]}
      theta      {set GM(theta) [second $p]}
      tolerance  {set GM(tolerance) [second $p]}
      xrayfilter {set GM(xrayfilter) [second $p]}
      gain       {set GM(gain) [second $p]}
      wcal0      {set GM(wcal0) [second $p]}
      wcal1      {set GM(wcal1) [second $p]}
      polyorder  {set GM(polyorder) [second $p]}
      options    {set GM(options) [second $p]}
      }
   }
}

proc GM.announce {} {
   global GM
   set-eg-option gainmatch [list \
        [list config [get GM config]] \
        [list velocity [get GM velocity]] \
        [list theta [get GM theta]] \
        [list velocity [get GM velocity]] \
        [list tolerance [get GM tolerance]] \
        [list xrayfilter [get GM xrayfilter]] \
        [list gain [get GM gain]] \
        [list wcal0 [get GM wcal0]] \
        [list wcal1 [get GM wcal1]] \
        [list polyorder [get GM polyorder]] \
        [list options [get GM options]] \
   ]
}

proc GM.save {} {edit-defaults gainmatch "set-eg-option gainmatch \{[get-eg-option gainmatch]\}"}

